MODULE gnuchcpf; (* FST *)

FROM SYSTEM IMPORT ASSEMBLER,ADR,SEGMENT;
FROM System IMPORT GetArg,ErrorMessage;
FROM FileSystem IMPORT File,Lookup,ReadNBytes,Close,done;
FROM Strings IMPORT CompareStr;

CONST pathmax = 260; BIOS=10H; tablenum=0;
VAR fontname: ARRAY [1..pathmax] OF CHAR; argn: CARDINAL;

PROCEDURE ResetFont;
CONST co8x16=1104H;
BEGIN
  ASM
    MOV AX,co8x16
    MOV BX,tablenum
    INT BIOS
  END
END ResetFont;

PROCEDURE ChangeFont;
CONST
  userchartab=1110H; bytesperchar=16; numchars=256; firstchar=0;
  bufmax=bytesperchar * numchars;
VAR
  fontfile: File; buf: ARRAY [1..bufmax] OF CHAR; bufseg,numread: CARDINAL;

BEGIN
  Lookup(fontfile,fontname,FALSE);
  IF (fontfile.res # done) THEN
    ErrorMessage("Couldn't open 8x16 font file!");
    HALT
  ELSE
    ReadNBytes(fontfile,ADR(buf),bufmax,numread);
    IF (numread # bufmax) THEN
      ErrorMessage("Couldn't find or read suitable 8x16 font file!");
      HALT
    ELSE
      bufseg := SEGMENT(buf);
      ASM
        MOV AX,userchartab
        MOV BH,bytesperchar
        MOV BL,tablenum
        MOV CX,numchars
        MOV DX,firstchar
        PUSH BP
        PUSH ES
        MOV DI,[bufseg]
        MOV ES,DI
        LEA BP,[buf]
        INT BIOS
        POP ES
        POP BP
      END
    END;
    Close(fontfile);
  END
END ChangeFont;

BEGIN
  GetArg(fontname,argn);
  IF (argn = 0) THEN
    ErrorMessage("No 8x16 font file specified!");
    HALT
  ELSIF (CompareStr(fontname,"-r") = 0) THEN
    ResetFont
  ELSE
    ChangeFont
  END
END gnuchcpf.
